/*

f-cpu/qdcpoc2/rop2.c
created Wed Jul 11 03:09:29 2001 by whygee@f-cpu.org
version Sun Aug  5 04:05:19 2001 (renaming from execution.c to rop2.c)

This file is included by f-cpu/qdcpoc2/main.c
which includes all the necessary stuffs.

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!

*/

void fc0_cycle_ROP2() {
  UMAX t5, tAND, tOR, tMUX;

  if (ROP2_exec !=0) {

/* stage 1.1 : */
    /* The ROP2 operation */
    t5 = (ROP2_function_bit0 & ~ROP2_input_0 & ~ROP2_input_1)
       | (ROP2_function_bit1 & ~ROP2_input_0 &  ROP2_input_1)
       | (ROP2_function_bit2 &  ROP2_input_0 & ~ROP2_input_1)
       | (ROP2_function_bit3 &  ROP2_input_0 &  ROP2_input_1);
  /* the exact order must be checked with the VHDL version... */

/* stage 1.2 : */
    /* MUX opcode : */
    tMUX = (ROP2_input_0 &  ROP2_input_2)
         | (ROP2_input_1 & ~ROP2_input_2);
    /* the order must also be verified. */

/* stage 2.1 : */
    /* a far better idea than a loop : compression and expansion */
    tAND = t5 & (t5 >> 1) & (t5 >> 2) & (t5 >> 4);
    tAND &= 0x0101010101010101LL;
    tAND |= (tAND << 1);
    tAND |= (tAND << 2);
    tAND |= (tAND << 4);

/* stage 2.2 : */
    tOR = t5 | (t5 >> 1) | (t5 >> 2) | (t5 >> 4);
    tOR &= 0x0101010101010101LL;
    tOR |= (tOR << 1);
    tOR |= (tOR << 2);
    tOR |= (tOR << 4);

/* stage 3 : the ending MUX */
    /* The final MUX : (this is not optimised for computing
        efficiency but shows how the VHDL looks like) */
    switch (ROP2_mode) {
      case ROP2_DIRECT_MODE : ROP2_output_port = t5;    break; /* 0: normal */
      case ROP2_AND_MODE    : ROP2_output_port = tAND;  break; /* 1: AND */
      case ROP2_OR_MODE     : ROP2_output_port = tOR;   break; /* 2: OR */
      case ROP2_MUX_MODE    : ROP2_output_port = tMUX;  break; /* 3: MUX */
      default: qdcpoc_error("Error in 'switch (ROP2_mode)'",13);
    }
  }
}
